' Nonogram Solving program.
' Copyright Adrian Millett 1996.

  DEFINT A-Z
DEF fnIsNum (a$) = (((ASC(a$) - 48) AND 255) < 10)

  bot = 29
  DIM non(128, 128)    ' NONOGRAM elements 0=Not defined. 1=FALSE,2=TRUE
  DIM cluex(128, 32)         ' Clue numbers for each column
  DIM cluey(128, 32)
  DIM solve(256)
  DIM clues(256)
  DIM nin(256)
  DIM colr(16)
  colr(0) = 0
  colr(1) = 14
  colr(2) = 1
  CLS
  PALETTE 0, 8
  COLOR 15
  PRINT "Adrians Nonogram Solving Program"
  PRINT "Copyright PC Solutions 1996, All Rights Reserved, Duplication Prohibited"
again:
  COLOR 10
  PRINT
  PRINT " Source file must be a text file with dimensions on 1st line, then"
  PRINT " X clues then Y clues on following lines."
  PRINT
  COLOR 15
  PRINT "Enter Name of Nonogram data file.. (Hit . for dir, RET to exit)"
  PRINT
  INPUT fil$
  IF fil$ = "!" THEN GOTO TestGap
  dbug = 0
  IF LEFT$(fil$, 1) = "=" THEN  ' Debug mode..
    dbug = 1
    fil$ = MID$(fil$, 2)
  END IF
  IF fil$ = "" THEN END
  IF fil$ = "/" THEN fil$ = "football.non"
  IF fil$ = "." THEN FILES "*.non": GOTO again
  OPEN fil$ FOR INPUT AS 1
    GOSUB ReadLine
    IF inerr THEN GOTO filerr
    nx = nin(1): ny = nin(2)
    IF nx < 2 OR ny < 2 THEN GOTO filerr
    FOR lx = 1 TO nx
      GOSUB ReadLine
      IF inerr THEN GOTO filerr
      IF dbug THEN PRINT lx; ":";
      FOR cc = 1 TO nread
        cluex(lx, cc) = nin(cc)
        IF dbug THEN PRINT nin(cc); ",";
      NEXT cc
      IF dbug THEN PRINT
    NEXT lx

    FOR ly = 1 TO ny
      GOSUB ReadLine
      IF inerr THEN GOTO filerr
      IF dbug THEN PRINT ly; ":";
      FOR cc = 1 TO nread
        cluey(ly, cc) = nin(cc)
        IF dbug THEN PRINT nin(cc); ",";
      NEXT cc
      IF dbug THEN PRINT
    NEXT ly
  CLOSE 1
  sqsize = 300 / ny   ' Set to zero for text output..
  hsq = sqsize / 2
  FOR x = 1 TO nx
    FOR y = 1 TO ny
      non(x, y) = 0      ' 0=Not defined. 1=FALSE,2=TRUE
    NEXT
  NEXT
  IF dbug THEN LINE INPUT i$
  SCREEN 12
  CLS
  'WIDTH 80, 50
  PALETTE 0, 65536 * 40
  PALETTE 1, 0
  'PALETTE 1, 0
  tim! = TIMER
  IF dbug THEN          ' print clues data
    LOCATE bot - 10, 1
    PRINT "X"; nx; ":";
    FOR x = 1 TO nx
      FOR cc = 1 TO 32
        PRINT MID$(STR$(cluex(x, cc)), 2);
        IF cluex(x, cc + 1) = 0 THEN EXIT FOR
        PRINT ",";
      NEXT
      PRINT ". ";
    NEXT
    PRINT
    PRINT "Y"; ny; ":";
    FOR y = 1 TO ny
      FOR cc = 1 TO 32
        PRINT MID$(STR$(cluey(y, cc)), 2);
        IF cluey(y, cc + 1) = 0 THEN EXIT FOR
        PRINT ",";
      NEXT
      PRINT ". ";
    NEXT
  END IF
  LOCATE bot - 3, 1: PRINT "(Hit ESC to abort)";
  iterate = 1
  WHILE (1)
    FOR lx = 1 TO nx
      GOSUB CheckESC
      FOR ly = 1 TO ny          '' Copy to solve array
        solve(ly) = non(lx, ly)
      NEXT ly
      nsolve = ny
      nclues = 0
      DO
        nclues = nclues + 1
        clues(nclues) = cluex(lx, nclues)
      LOOP WHILE (clues(nclues))
      GOSUB SolveLine   '' Solve (clues) and (solve) array
      FOR ly = 1 TO ny          '' Copy result back from solve array
        non(lx, ly) = solve(ly)
      NEXT ly
      GOSUB ShowResult
    NEXT lx
    FOR ly = 1 TO ny
      GOSUB CheckESC
      FOR lx = 1 TO nx          '' Copy to solve array
        solve(lx) = non(lx, ly)
      NEXT lx
      nsolve = nx
      nclues = 0
      DO
        nclues = nclues + 1
        clues(nclues) = cluey(ly, nclues)
      LOOP WHILE (clues(nclues))
      GOSUB SolveLine   '' Solve (clues) and (solve) array
      FOR lx = 1 TO nx          '' Copy result back from solve array
        non(lx, ly) = solve(lx)
      NEXT lx
      GOSUB ShowResult
    NEXT ly
    iterate = iterate + 1
  WEND
  END

CheckESC:
  IF INKEY$ <> CHR$(27) THEN RETURN
  COLOR 12
  LOCATE bot - 2, 1
  PRINT "Program Aborted"
  END

filerr:
  BEEP
  PRINT "Bad line:"; in$
  CLOSE
  END

ReadLine:
  inerr = 0
  nin(0) = 0
  nread = 0
  LINE INPUT #1, in$
  IF EOF(1) THEN inerr = 1: RETURN
  PRINT ">"; in$
  IF in$ = "" THEN GOTO ReadLine
  IF fnIsNum(in$) = 0 GOTO ReadLine
        ' OK, starts with number
  nread = 0
  WHILE (1)
    nread = nread + 1
    nin(nread) = VAL(in$)
    nin(nread + 1) = 0
    x = 1
    DO
      a$ = MID$(in$, x, 1)
      IF fnIsNum(a$) = 0 THEN
        IF a$ <> "," THEN RETURN
        in$ = MID$(in$, x + 1)
        IF in$ = "" OR fnIsNum(in$) = 0 THEN RETURN
        EXIT DO
      END IF
      x = x + 1
      IF (x > LEN(in$)) THEN RETURN
    LOOP WHILE (1)
  WEND

ShowResult:
    isover = 1
    FOR x = 1 TO nx
      FOR y = 1 TO ny
        IF non(x, y) = 0 THEN isover = 0
      NEXT y
    NEXT x
    IF isover = 0 THEN
      IF lasttim& = INT(TIMER) THEN RETURN
    END IF
    lasttim& = TIMER
    LOCATE bot - 1, 1:
    COLOR 14
    PRINT "Iteration:"; iterate; ", x,y="; lx, ly; " Time:"; INT(TIMER - tim!);
    LOCATE 1, 1
    COLOR 10
    IF sqsize THEN
      py = sqsize
      FOR y = 1 TO ny          '' Copy to solve array
        px = sqsize
        FOR x = 1 TO nx
          res = colr(non(x, y))
          LINE (px, py)-(px + sqsize - 1, py + sqsize - 1), res, BF
          PSET (px + hsq, py + hsq), 7
          px = px + sqsize
        NEXT x
        py = py + sqsize
      NEXT y
      LOCATE 17, 1
    ELSE
      FOR y = 1 TO ny          '' Copy to solve array
        FOR x = 1 TO nx
          PRINT MID$("?.*    ", 1 + non(x, y), 1);
        NEXT
        PRINT
      NEXT
    END IF
    IF isover THEN
      LOCATE bot - 4, 1
      COLOR 12
      PRINT "NONOGRAM SOLVED in"; TIMER - tim!; "Seconds."
      PRINT "Hit SPACE to run again, S to save, ESC to end"
      BEEP: BEEP
      WHILE (1)
        a$ = INKEY$
        IF a$ = " " THEN RUN
        IF a$ = "s" THEN GOSUB SaveNon: RUN
        IF a$ = CHR$(27) THEN END
      WEND
    END IF
    IF dbug THEN
      PRINT : PRINT "Hit Enter:";
      LINE INPUT i$
    END IF
  RETURN

SaveNon:
  CLS
  ofil$ = "non.txt"
  INPUT "Enter Filename (ret=NON.TXT)"; ofil$
  IF ofil$ = "" THEN END
  OPEN ofil$ FOR OUTPUT AS 1
    PRINT #1, "Result for nonogram '"; fil$; "'"
    PRINT #1, ""
    FOR y = 1 TO ny          '' Copy to solve array
      FOR x = 1 TO nx
        PRINT #1, MID$("?.*    ", 1 + non(x, y), 1); " ";
      NEXT
      PRINT #1, ""
    NEXT
    
  CLOSE
  RETURN

DIM gaps(256)
DIM mingap(256)         ' Minimum gap size
DIM maxgap(256)
DIM result(256)
DIM try(256)

InitGap:
  FOR s = 1 TO ngaps - 1
    gaps(s) = 0
    maxgap(s) = slack
  NEXT
  gaps(ngaps) = slack
  ptr = ngaps - 1
  RETURN

NextGap:
  gaps(ptr) = gaps(ptr) + 1
  IF (gaps(ptr) > maxgap(ptr)) THEN
    ptr = ptr - 1
    IF (ptr < 0) THEN RETURN
    GOTO NextGap
  ELSE
    FOR cc = ptr + 1 TO ngaps
      gaps(cc) = 0
      maxgap(cc) = maxgap(cc - 1) - gaps(cc - 1)
    NEXT
    gaps(ngaps) = maxgap(ngaps)
    ptr = ngaps - 1
  END IF
  RETURN

 ' Given a list of clues(nclues), fill in mathing solutions in solve(nsolve)
SolveLine:
  spaces = nsolve       ' Count how many spaces..
  nclues = nclues - 1
  FOR x = 1 TO nclues
    spaces = spaces - clues(x)
  NEXT x
  ngaps = nclues + 1
  IF dbug THEN
    LOCATE bot - 10, 1: PRINT "spaces"; spaces; "clu"; nclues; ":";
  END IF
  FOR cgap = 1 TO ngaps
    IF (cgap = 1 OR cgap = ngaps) THEN  '' End/start gap
      mingap(cgap) = 0
      maxgap(cgap) = spaces - nclues + 1
    ELSE
      mingap(cgap) = 1
      maxgap(cgap) = spaces - nclues + 2
    END IF
    gaps(cgap) = mingap(cgap)           '' Initialise gap counts
    IF dbug THEN
      PRINT "("; mingap(cgap); "-"; maxgap(cgap); ")+"; clues(cgap);
    END IF
  NEXT
  FOR x = 1 TO nsolve           '' Clear old results.
    result(x) = 0
  NEXT x
  slack = spaces - nclues + 1
  GOSUB InitGap    ' Ensure 1st gap-combo is legal
  DO

    cpos = 1
    FOR cgap = 1 TO ngaps
      x = cpos
      WHILE (x < cpos + gaps(cgap) + mingap(cgap))
        IF solve(x) = 2 THEN GOTO NextCombo     ' a "TRUE" in gap-This combo fails
        x = x + 1
      WEND
      cpos = cpos + gaps(cgap) + mingap(cgap)
      x = cpos
      WHILE (x < cpos + clues(cgap))
        IF solve(x) = 1 THEN GOTO NextCombo     ' a "FALSE" in row-This combo fails
        x = x + 1
      WEND
      cpos = cpos + clues(cgap)
    NEXT
        ' OK this combo COULD match, so mark off true/falses in RESULT
    cpos = 1
    FOR cgap = 1 TO ngaps
      x = cpos
      WHILE (x < cpos + gaps(cgap) + mingap(cgap))
        result(x) = result(x) OR 1      '' Mark a FALSE (gap)
        x = x + 1
      WEND
      cpos = cpos + gaps(cgap) + mingap(cgap)
      x = cpos
      WHILE (x < cpos + clues(cgap))
        result(x) = result(x) OR 2      '' Mark a TRUE (row)
        x = x + 1
      WEND
      cpos = cpos + clues(cgap)
    NEXT
NextCombo:
    GOSUB NextGap                        ' Next gap combo..
  LOOP WHILE (ptr > 0)
                        ' OK, transfer RESULT back to SOLVE array.
  FOR x = 1 TO nsolve
    IF (solve(x) = 0) THEN      ' Not yet resolved
      r = result(x)
      IF r = 1 THEN solve(x) = 1          ' Definate (FALSE) gap
      IF r = 2 THEN solve(x) = 2          ' Definate (TRUE) row
    END IF
  NEXT x
  RETURN

'
TestGap:
  INPUT "Ngaps,slack"; ngaps, slack
  GOSUB InitGap
  z = 0
  DO
    PRINT "(";
    FOR x = 1 TO ngaps
      PRINT gaps(x);
    NEXT
    PRINT ")",
    GOSUB NextGap
    z = z + 1
  LOOP WHILE ptr > 0
  PRINT
  PRINT "n="; z
  GOTO TestGap

